Index: uspace/drv/nic/ar9271/htc.c
===================================================================
--- uspace/drv/nic/ar9271/htc.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/nic/ar9271/htc.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -36,5 +36,4 @@
 #include <byteorder.h>
 #include <errno.h>
-#include <str_error.h>
 #include "wmi.h"
 #include "htc.h"
@@ -66,5 +65,5 @@
 }
 
-errno_t htc_init_new_vif(htc_device_t *htc_device)
+int htc_init_new_vif(htc_device_t *htc_device)
 {
 	htc_vif_msg_t vif_msg;
@@ -150,8 +149,8 @@
  * @param endpoint_id Destination endpoint.
  *
- * @return EOK if succeed, error code otherwise.
- *
- */
-errno_t htc_send_control_message(htc_device_t *htc_device, void *buffer,
+ * @return EOK if succeed, negative error code otherwise.
+ *
+ */
+int htc_send_control_message(htc_device_t *htc_device, void *buffer,
     size_t buffer_size, uint8_t endpoint_id)
 {
@@ -173,8 +172,8 @@
  * @param endpoint_id Destination endpoint.
  *
- * @return EOK if succeed, error code otherwise.
- *
- */
-errno_t htc_send_data_message(htc_device_t *htc_device, void *buffer,
+ * @return EOK if succeed, negative error code otherwise.
+ *
+ */
+int htc_send_data_message(htc_device_t *htc_device, void *buffer,
     size_t buffer_size, uint8_t endpoint_id)
 {
@@ -196,8 +195,8 @@
  * @param transferred_size Real size of read data.
  *
- * @return EOK if succeed, error code otherwise.
- *
- */
-errno_t htc_read_data_message(htc_device_t *htc_device, void *buffer,
+ * @return EOK if succeed, negative error code otherwise.
+ *
+ */
+int htc_read_data_message(htc_device_t *htc_device, void *buffer,
     size_t buffer_size, size_t *transferred_size)
 {
@@ -216,8 +215,8 @@
  * @param transferred_size Real size of read data.
  *
- * @return EOK if succeed, error code otherwise.
- *
- */
-errno_t htc_read_control_message(htc_device_t *htc_device, void *buffer,
+ * @return EOK if succeed, negative error code otherwise.
+ *
+ */
+int htc_read_control_message(htc_device_t *htc_device, void *buffer,
     size_t buffer_size, size_t *transferred_size)
 {
@@ -236,8 +235,8 @@
  *
  * @return EOK if succeed, EINVAL when failed to connect service,
- *         error code otherwise.
- *
- */
-static errno_t htc_connect_service(htc_device_t *htc_device,
+ *         negative error code otherwise.
+ *
+ */
+static int htc_connect_service(htc_device_t *htc_device,
     wmi_services_t service_id, int *response_endpoint_no)
 {
@@ -261,9 +260,9 @@
 	
 	/* Send HTC message. */
-	errno_t rc = htc_send_control_message(htc_device, buffer, buffer_size,
+	int rc = htc_send_control_message(htc_device, buffer, buffer_size,
 	    htc_device->endpoints.ctrl_endpoint);
 	if (rc != EOK) {
 		free(buffer);
-		usb_log_error("Failed to send HTC message. Error: %s\n", str_error_name(rc));
+		usb_log_error("Failed to send HTC message. Error: %d\n", rc);
 		return rc;
 	}
@@ -279,5 +278,5 @@
 		free(buffer);
 		usb_log_error("Failed to receive HTC service connect response. "
-		    "Error: %s\n", str_error_name(rc));
+		    "Error: %d\n", rc);
 		return rc;
 	}
@@ -309,8 +308,8 @@
  * @param htc_device HTC device structure.
  *
- * @return EOK if succeed, error code otherwise.
- *
- */
-static errno_t htc_config_credits(htc_device_t *htc_device)
+ * @return EOK if succeed, negative error code otherwise.
+ *
+ */
+static int htc_config_credits(htc_device_t *htc_device)
 {
 	size_t buffer_size = sizeof(htc_frame_header_t) +
@@ -327,10 +326,10 @@
 	
 	/* Send HTC message. */
-	errno_t rc = htc_send_control_message(htc_device, buffer, buffer_size,
+	int rc = htc_send_control_message(htc_device, buffer, buffer_size,
 	    htc_device->endpoints.ctrl_endpoint);
 	if (rc != EOK) {
 		free(buffer);
 		usb_log_error("Failed to send HTC config message. "
-		    "Error: %s\n", str_error_name(rc));
+		    "Error: %d\n", rc);
 		return rc;
 	}
@@ -345,5 +344,5 @@
 	if (rc != EOK) {
 		usb_log_error("Failed to receive HTC config response message. "
-		    "Error: %s\n", str_error_name(rc));
+		    "Error: %d\n", rc);
 	}
 	
@@ -357,8 +356,8 @@
  * @param htc_device HTC device structure.
  *
- * @return EOK if succeed, error code otherwise.
- *
- */
-static errno_t htc_complete_setup(htc_device_t *htc_device)
+ * @return EOK if succeed, negative error code otherwise.
+ *
+ */
+static int htc_complete_setup(htc_device_t *htc_device)
 {
 	size_t buffer_size = sizeof(htc_frame_header_t) +
@@ -373,9 +372,9 @@
 	
 	/* Send HTC message. */
-	errno_t rc = htc_send_control_message(htc_device, buffer, buffer_size,
+	int rc = htc_send_control_message(htc_device, buffer, buffer_size,
 	    htc_device->endpoints.ctrl_endpoint);
 	if (rc != EOK)
 		usb_log_error("Failed to send HTC setup complete message. "
-		    "Error: %s\n", str_error_name(rc));
+		    "Error: %d\n", rc);
 	
 	free(buffer);
@@ -391,8 +390,8 @@
  *
  * @return EOK if succeed, EINVAL if response error,
- *         error code otherwise.
- *
- */
-static errno_t htc_check_ready(htc_device_t *htc_device)
+ *         negative error code otherwise.
+ *
+ */
+static int htc_check_ready(htc_device_t *htc_device)
 {
 	size_t buffer_size = htc_device->ath_device->ctrl_response_length;
@@ -400,10 +399,10 @@
 	
 	/* Read response from device. */
-	errno_t rc = htc_read_control_message(htc_device, buffer, buffer_size,
+	int rc = htc_read_control_message(htc_device, buffer, buffer_size,
 	    NULL);
 	if (rc != EOK) {
 		free(buffer);
 		usb_log_error("Failed to receive HTC check ready message. "
-		    "Error: %s\n", str_error_name(rc));
+		    "Error: %d\n", rc);
 		return rc;
 	}
@@ -427,8 +426,8 @@
  * @param htc_device HTC device structure to be initialized.
  *
- * @return EOK if succeed, error code otherwise.
- *
- */
-errno_t htc_device_init(ath_t *ath_device, ieee80211_dev_t *ieee80211_dev,
+ * @return EOK if succeed, negative error code otherwise.
+ *
+ */
+int htc_device_init(ath_t *ath_device, ieee80211_dev_t *ieee80211_dev,
     htc_device_t *htc_device)
 {
@@ -448,11 +447,11 @@
  * @param htc_device HTC device structure.
  *
- * @return EOK if succeed, error code otherwise.
- *
- */
-errno_t htc_init(htc_device_t *htc_device)
+ * @return EOK if succeed, negative error code otherwise.
+ *
+ */
+int htc_init(htc_device_t *htc_device)
 {
 	/* First check ready message in device. */
-	errno_t rc = htc_check_ready(htc_device);
+	int rc = htc_check_ready(htc_device);
 	if (rc != EOK) {
 		usb_log_error("Device is not in ready state after loading "
Index: uspace/drv/nic/ar9271/htc.h
===================================================================
--- uspace/drv/nic/ar9271/htc.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/nic/ar9271/htc.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -297,11 +297,11 @@
 } __attribute__((packed)) htc_setup_complete_msg_t;
 
-extern errno_t htc_device_init(ath_t *, ieee80211_dev_t *, htc_device_t *);
-extern errno_t htc_init(htc_device_t *);
-extern errno_t htc_init_new_vif(htc_device_t *);
-extern errno_t htc_read_control_message(htc_device_t *, void *, size_t, size_t *);
-extern errno_t htc_read_data_message(htc_device_t *, void *, size_t, size_t *);
-extern errno_t htc_send_control_message(htc_device_t *, void *, size_t, uint8_t);
-extern errno_t htc_send_data_message(htc_device_t *, void *, size_t, uint8_t);
+extern int htc_device_init(ath_t *, ieee80211_dev_t *, htc_device_t *);
+extern int htc_init(htc_device_t *);
+extern int htc_init_new_vif(htc_device_t *);
+extern int htc_read_control_message(htc_device_t *, void *, size_t, size_t *);
+extern int htc_read_data_message(htc_device_t *, void *, size_t, size_t *);
+extern int htc_send_control_message(htc_device_t *, void *, size_t, uint8_t);
+extern int htc_send_data_message(htc_device_t *, void *, size_t, uint8_t);
 
 #endif  /* ATHEROS_HTC_H */
Index: uspace/drv/nic/ar9271/hw.c
===================================================================
--- uspace/drv/nic/ar9271/hw.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/nic/ar9271/hw.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -49,8 +49,8 @@
  *
  * @return EOK if succeed, ETIMEOUT on timeout,
- *         error code otherwise.
+ *         negative error code otherwise.
  *
  */
-static errno_t hw_read_wait(ar9271_t *ar9271, uint32_t offset, uint32_t mask,
+static int hw_read_wait(ar9271_t *ar9271, uint32_t offset, uint32_t mask,
     uint32_t value)
 {
@@ -67,5 +67,5 @@
 }
 
-static errno_t hw_reset_power_on(ar9271_t *ar9271)
+static int hw_reset_power_on(ar9271_t *ar9271)
 {
 	wmi_reg_t buffer[] = {
@@ -93,5 +93,5 @@
 	wmi_reg_write(ar9271->htc_device, AR9271_RTC_RESET, 1);
 	
-	errno_t rc = hw_read_wait(ar9271,
+	int rc = hw_read_wait(ar9271,
 	    AR9271_RTC_STATUS,
 	    AR9271_RTC_STATUS_MASK,
@@ -105,5 +105,5 @@
 }
 
-static errno_t hw_set_reset(ar9271_t *ar9271, bool cold)
+static int hw_set_reset(ar9271_t *ar9271, bool cold)
 {
 	uint32_t reset_value = AR9271_RTC_RC_MAC_WARM;
@@ -135,5 +135,5 @@
 	wmi_reg_write(ar9271->htc_device, AR9271_RTC_RC, 0);
 	
-	errno_t rc = hw_read_wait(ar9271, AR9271_RTC_RC, AR9271_RTC_RC_MASK, 0);
+	int rc = hw_read_wait(ar9271, AR9271_RTC_RC, AR9271_RTC_RC_MASK, 0);
 	if (rc != EOK) {
 		usb_log_error("Failed to wait for RTC RC register.\n");
@@ -148,5 +148,5 @@
 }
 
-static errno_t hw_addr_init(ar9271_t *ar9271)
+static int hw_addr_init(ar9271_t *ar9271)
 {
 	uint32_t value;
@@ -164,5 +164,5 @@
 	nic_t *nic = nic_get_from_ddf_dev(ar9271->ddf_dev);
 	
-	errno_t rc = nic_report_address(nic, &ar9271_address);
+	int rc = nic_report_address(nic, &ar9271_address);
 	if (rc != EOK) {
 		usb_log_error("Failed to report NIC HW address.\n");
@@ -173,5 +173,5 @@
 }
 
-static errno_t hw_gpio_set_output(ar9271_t *ar9271, uint32_t gpio, uint32_t type)
+static int hw_gpio_set_output(ar9271_t *ar9271, uint32_t gpio, uint32_t type)
 {
 	uint32_t address;
@@ -204,5 +204,5 @@
 }
 
-static errno_t hw_gpio_set_value(ar9271_t *ar9271, uint32_t gpio, uint32_t value)
+static int hw_gpio_set_value(ar9271_t *ar9271, uint32_t gpio, uint32_t value)
 {
 	wmi_reg_set_clear_bit(ar9271->htc_device, AR9271_GPIO_IN_OUT,
@@ -215,10 +215,10 @@
  * @param ar9271 Device structure.
  *
- * @return EOK if succeed, error code otherwise.
+ * @return EOK if succeed, negative error code otherwise.
  *
  */
-static errno_t hw_init_proc(ar9271_t *ar9271)
-{
-	errno_t rc = hw_reset_power_on(ar9271);
+static int hw_init_proc(ar9271_t *ar9271)
+{
+	int rc = hw_reset_power_on(ar9271);
 	if (rc != EOK) {
 		usb_log_error("Failed to HW reset power on.\n");
@@ -241,7 +241,7 @@
 }
 
-static errno_t hw_init_led(ar9271_t *ar9271)
-{
-	errno_t rc = hw_gpio_set_output(ar9271, AR9271_LED_PIN,
+static int hw_init_led(ar9271_t *ar9271)
+{
+	int rc = hw_gpio_set_output(ar9271, AR9271_LED_PIN,
 	    AR9271_GPIO_OUT_MUX_AS_OUT);
 	if (rc != EOK) {
@@ -259,5 +259,5 @@
 }
 
-static errno_t hw_activate_phy(ar9271_t *ar9271)
+static int hw_activate_phy(ar9271_t *ar9271)
 {
 	wmi_reg_write(ar9271->htc_device, AR9271_PHY_ACTIVE, 1);
@@ -267,5 +267,5 @@
 }
 
-static errno_t hw_set_operating_mode(ar9271_t *ar9271,
+static int hw_set_operating_mode(ar9271_t *ar9271,
     ieee80211_operating_mode_t op_mode)
 {
@@ -295,7 +295,7 @@
 }
 
-static errno_t hw_reset_operating_mode(ar9271_t *ar9271)
-{
-	errno_t rc = hw_set_operating_mode(ar9271, IEEE80211_OPMODE_STATION);
+static int hw_reset_operating_mode(ar9271_t *ar9271)
+{
+	int rc = hw_set_operating_mode(ar9271, IEEE80211_OPMODE_STATION);
 	if (rc != EOK) {
 		usb_log_error("Failed to set opmode to station.\n");
@@ -306,5 +306,5 @@
 }
 
-static errno_t hw_noise_floor_calibration(ar9271_t *ar9271)
+static int hw_noise_floor_calibration(ar9271_t *ar9271)
 {
 	uint32_t value;
@@ -325,5 +325,5 @@
 	    AR9271_AGC_CONTROL_NF_CALIB);
 	
-	errno_t rc = hw_read_wait(ar9271, AR9271_AGC_CONTROL,
+	int rc = hw_read_wait(ar9271, AR9271_AGC_CONTROL,
 	    AR9271_AGC_CONTROL_NF_CALIB, 0);
 	if (rc != EOK) {
@@ -344,5 +344,5 @@
 }
 
-static errno_t hw_set_freq(ar9271_t *ar9271, uint16_t freq)
+static int hw_set_freq(ar9271_t *ar9271, uint16_t freq)
 {
 	/* Not supported channel frequency. */
@@ -373,9 +373,9 @@
 }
 
-errno_t hw_freq_switch(ar9271_t *ar9271, uint16_t freq)
+int hw_freq_switch(ar9271_t *ar9271, uint16_t freq)
 {
 	wmi_reg_write(ar9271->htc_device, AR9271_PHY_RFBUS_KILL, 0x1);
 	
-	errno_t rc = hw_read_wait(ar9271, AR9271_PHY_RFBUS_GRANT, 0x1, 0x1);
+	int rc = hw_read_wait(ar9271, AR9271_PHY_RFBUS_GRANT, 0x1, 0x1);
 	if (rc != EOK) {
 		usb_log_error("Failed to kill RF bus.\n");
@@ -407,5 +407,5 @@
 }
 
-errno_t hw_set_rx_filter(ar9271_t *ar9271, bool assoc)
+int hw_set_rx_filter(ar9271_t *ar9271, bool assoc)
 {
 	uint32_t additional_bits = 0;
@@ -425,5 +425,5 @@
 }
 
-errno_t hw_set_bssid(ar9271_t *ar9271)
+int hw_set_bssid(ar9271_t *ar9271)
 {
 	ieee80211_dev_t *ieee80211_dev = ar9271->ieee80211_dev;
@@ -445,10 +445,10 @@
 }
 
-errno_t hw_rx_init(ar9271_t *ar9271)
+int hw_rx_init(ar9271_t *ar9271)
 {
 	wmi_reg_write(ar9271->htc_device, AR9271_COMMAND,
 	    AR9271_COMMAND_RX_ENABLE);
 	
-	errno_t rc = hw_set_rx_filter(ar9271, false);
+	int rc = hw_set_rx_filter(ar9271, false);
 	if (rc != EOK) {
 		usb_log_error("Failed to set RX filtering.\n");
@@ -465,5 +465,5 @@
 }
 
-static errno_t hw_init_pll(ar9271_t *ar9271)
+static int hw_init_pll(ar9271_t *ar9271)
 {
 	/* Some magic here (set for 2GHz channels). But VERY important :-) */
@@ -510,5 +510,5 @@
 }
 
-static errno_t hw_calibration(ar9271_t *ar9271)
+static int hw_calibration(ar9271_t *ar9271)
 {
 	wmi_reg_set_bit(ar9271->htc_device, AR9271_CARRIER_LEAK_CONTROL,
@@ -523,5 +523,5 @@
 	    AR9271_AGC_CONTROL_CALIB);
 	
-	errno_t rc = hw_read_wait(ar9271, AR9271_AGC_CONTROL,
+	int rc = hw_read_wait(ar9271, AR9271_AGC_CONTROL,
 	    AR9271_AGC_CONTROL_CALIB, 0);
 	if (rc != EOK) {
@@ -540,5 +540,5 @@
 }
 
-errno_t hw_reset(ar9271_t *ar9271)
+int hw_reset(ar9271_t *ar9271)
 {
 	/* Set physical layer as deactivated. */
@@ -559,5 +559,5 @@
 		hw_set_reset(ar9271, true);
 	
-	errno_t rc = hw_init_pll(ar9271);
+	int rc = hw_init_pll(ar9271);
 	if (rc != EOK) {
 		usb_log_error("Failed to init PLL.\n");
@@ -636,9 +636,9 @@
  * @param ar9271 Device structure.
  *
- * @return EOK if succeed, error code otherwise.
+ * @return EOK if succeed, negative error code otherwise.
  */
-errno_t hw_init(ar9271_t *ar9271)
-{
-	errno_t rc = hw_init_proc(ar9271);
+int hw_init(ar9271_t *ar9271)
+{
+	int rc = hw_init_proc(ar9271);
 	if (rc != EOK) {
 		usb_log_error("Failed to HW reset device.\n");
Index: uspace/drv/nic/ar9271/hw.h
===================================================================
--- uspace/drv/nic/ar9271/hw.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/nic/ar9271/hw.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -41,10 +41,10 @@
 #define HW_WAIT_TIME_US  10
 
-extern errno_t hw_init(ar9271_t *);
-extern errno_t hw_freq_switch(ar9271_t *, uint16_t);
-extern errno_t hw_rx_init(ar9271_t *);
-extern errno_t hw_reset(ar9271_t *);
-extern errno_t hw_set_bssid(ar9271_t *);
-extern errno_t hw_set_rx_filter(ar9271_t *, bool);
+extern int hw_init(ar9271_t *);
+extern int hw_freq_switch(ar9271_t *, uint16_t);
+extern int hw_rx_init(ar9271_t *);
+extern int hw_reset(ar9271_t *);
+extern int hw_set_bssid(ar9271_t *);
+extern int hw_set_rx_filter(ar9271_t *, bool);
 
 #endif  /* ATHEROS_HW_H */
Index: uspace/drv/nic/ar9271/wmi.c
===================================================================
--- uspace/drv/nic/ar9271/wmi.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/nic/ar9271/wmi.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -35,5 +35,4 @@
 #include <usb/debug.h>
 #include <errno.h>
-#include <str_error.h>
 #include <stdlib.h>
 #include <mem.h>
@@ -47,8 +46,8 @@
  * @param res        Stored result.
  *
- * @return EOK if succeed, error code otherwise.
- *
- */
-errno_t wmi_reg_read(htc_device_t *htc_device, uint32_t reg_offset, uint32_t *res)
+ * @return EOK if succeed, negative error code otherwise.
+ *
+ */
+int wmi_reg_read(htc_device_t *htc_device, uint32_t reg_offset, uint32_t *res)
 {
 	uint32_t cmd_value = host2uint32_t_be(reg_offset);
@@ -57,5 +56,5 @@
 	    malloc(htc_device->ath_device->ctrl_response_length);
 	
-	errno_t rc = wmi_send_command(htc_device, WMI_REG_READ,
+	int rc = wmi_send_command(htc_device, WMI_REG_READ,
 	    (uint8_t *) &cmd_value, sizeof(cmd_value), resp_buffer);
 	
@@ -79,8 +78,8 @@
  * @param val        Value to be written
  *
- * @return EOK if succeed, error code otherwise.
- *
- */
-errno_t wmi_reg_write(htc_device_t *htc_device, uint32_t reg_offset, uint32_t val)
+ * @return EOK if succeed, negative error code otherwise.
+ *
+ */
+int wmi_reg_write(htc_device_t *htc_device, uint32_t reg_offset, uint32_t val)
 {
 	uint32_t cmd_buffer[] = {
@@ -92,5 +91,5 @@
 	    malloc(htc_device->ath_device->ctrl_response_length);
 	
-	errno_t rc = wmi_send_command(htc_device, WMI_REG_WRITE,
+	int rc = wmi_send_command(htc_device, WMI_REG_WRITE,
 	    (uint8_t *) &cmd_buffer, sizeof(cmd_buffer), resp_buffer);
 	
@@ -112,13 +111,13 @@
  * @param clear_bit  Bit to be cleared.
  *
- * @return EOK if succeed, error code otherwise.
- *
- */
-errno_t wmi_reg_set_clear_bit(htc_device_t *htc_device, uint32_t reg_offset,
+ * @return EOK if succeed, negative error code otherwise.
+ *
+ */
+int wmi_reg_set_clear_bit(htc_device_t *htc_device, uint32_t reg_offset,
     uint32_t set_bit, uint32_t clear_bit)
 {
 	uint32_t value;
 	
-	errno_t rc = wmi_reg_read(htc_device, reg_offset, &value);
+	int rc = wmi_reg_read(htc_device, reg_offset, &value);
 	if (rc != EOK) {
 		usb_log_error("Failed to read registry value in RMW "
@@ -146,8 +145,8 @@
  * @param set_bit    Bit to be set.
  *
- * @return EOK if succeed, error code otherwise.
- *
- */
-errno_t wmi_reg_set_bit(htc_device_t *htc_device, uint32_t reg_offset,
+ * @return EOK if succeed, negative error code otherwise.
+ *
+ */
+int wmi_reg_set_bit(htc_device_t *htc_device, uint32_t reg_offset,
     uint32_t set_bit)
 {
@@ -161,8 +160,8 @@
  * @param clear_bit  Bit to be cleared.
  *
- * @return EOK if succeed, error code otherwise.
- *
- */
-errno_t wmi_reg_clear_bit(htc_device_t *htc_device, uint32_t reg_offset,
+ * @return EOK if succeed, negative error code otherwise.
+ *
+ */
+int wmi_reg_clear_bit(htc_device_t *htc_device, uint32_t reg_offset,
     uint32_t clear_bit)
 {
@@ -176,8 +175,8 @@
  * @param elements   Number of elements in array.
  *
- * @return EOK if succeed, error code otherwise.
- *
- */
-errno_t wmi_reg_buffer_write(htc_device_t *htc_device, wmi_reg_t *reg_buffer,
+ * @return EOK if succeed, negative error code otherwise.
+ *
+ */
+int wmi_reg_buffer_write(htc_device_t *htc_device, wmi_reg_t *reg_buffer,
     size_t elements)
 {
@@ -198,5 +197,5 @@
 	}
 	
-	errno_t rc = wmi_send_command(htc_device, WMI_REG_WRITE,
+	int rc = wmi_send_command(htc_device, WMI_REG_WRITE,
 	    (uint8_t *) buffer, buffer_size, resp_buffer);
 	
@@ -220,8 +219,8 @@
  * @param response_buffer Buffer with response data.
  *
- * @return EOK if succeed, error code otherwise.
- *
- */
-errno_t wmi_send_command(htc_device_t *htc_device, wmi_command_t command_id,
+ * @return EOK if succeed, negative error code otherwise.
+ *
+ */
+int wmi_send_command(htc_device_t *htc_device, wmi_command_t command_id,
     uint8_t *command_buffer, uint32_t command_length, void *response_buffer)
 {
@@ -242,9 +241,9 @@
 	
 	/* Send message. */
-	errno_t rc = htc_send_control_message(htc_device, buffer, buffer_size,
+	int rc = htc_send_control_message(htc_device, buffer, buffer_size,
 	    htc_device->endpoints.wmi_endpoint);
 	if (rc != EOK) {
 		free(buffer);
-		usb_log_error("Failed to send WMI message. Error: %s\n", str_error_name(rc));
+		usb_log_error("Failed to send WMI message. Error: %d\n", rc);
 		return rc;
 	}
@@ -269,5 +268,5 @@
 			free(buffer);
 			usb_log_error("Failed to receive WMI message response. "
-			    "Error: %s\n", str_error_name(rc));
+			    "Error: %d\n", rc);
 			return rc;
 		}
Index: uspace/drv/nic/ar9271/wmi.h
===================================================================
--- uspace/drv/nic/ar9271/wmi.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/nic/ar9271/wmi.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -117,11 +117,11 @@
 } wmi_reg_t;
 
-extern errno_t wmi_reg_read(htc_device_t *, uint32_t, uint32_t *);
-extern errno_t wmi_reg_write(htc_device_t *, uint32_t, uint32_t);
-extern errno_t wmi_reg_set_clear_bit(htc_device_t *, uint32_t, uint32_t, uint32_t);
-extern errno_t wmi_reg_set_bit(htc_device_t *, uint32_t, uint32_t);
-extern errno_t wmi_reg_clear_bit(htc_device_t *, uint32_t, uint32_t);
-extern errno_t wmi_reg_buffer_write(htc_device_t *, wmi_reg_t *, size_t);
-extern errno_t wmi_send_command(htc_device_t *, wmi_command_t, uint8_t *, uint32_t,
+extern int wmi_reg_read(htc_device_t *, uint32_t, uint32_t *);
+extern int wmi_reg_write(htc_device_t *, uint32_t, uint32_t);
+extern int wmi_reg_set_clear_bit(htc_device_t *, uint32_t, uint32_t, uint32_t);
+extern int wmi_reg_set_bit(htc_device_t *, uint32_t, uint32_t);
+extern int wmi_reg_clear_bit(htc_device_t *, uint32_t, uint32_t);
+extern int wmi_reg_buffer_write(htc_device_t *, wmi_reg_t *, size_t);
+extern int wmi_send_command(htc_device_t *, wmi_command_t, uint8_t *, uint32_t,
     void *);
 
